## lomiri-action-api 1.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

project(lomiri-action VERSION 1.1.2 LANGUAGES CXX C)

if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

option(basic_warnings "Basic compiler warnings." ON)
option(use_libhud2 "Use external libhud2 lib" ON)
include(FindPkgConfig)

if (use_libhud2)
    pkg_search_module(HUD REQUIRED hud-2)
else()
    pkg_check_modules(GLIB2 REQUIRED glib-2.0)
    include_directories(${GLIB2_INCLUDE_DIRS})

    pkg_check_modules(GOBJECT2 REQUIRED gobject-2.0)
    include_directories(${GOBJECT2_INCLUDE_DIRS})

    pkg_check_modules(GIO2 REQUIRED gio-2.0)
    include_directories(${GIO2_INCLUDE_DIRS})
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11 -fno-permissive -pedantic -Wall -Wextra")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

if(${basic_warnings})
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic")
endif()

# Standard install paths
include(GNUInstallDirs)

set(LIBDIR "lib" CACHE PATH "Destination install dir for the library")

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# enable QML debugging
string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.
if(cmake_build_type_lower MATCHES "debug")
    add_definitions(-DQT_QML_DEBUG)
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks
add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                       ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)
find_package(Qt5Quick REQUIRED)

include_directories(include)
add_subdirectory(src)
add_subdirectory(qml)
add_subdirectory(examples)

option(GENERATE_DOCUMENTATION "Generate documenation for C++ and QML" OFF)
if(${GENERATE_DOCUMENTATION})
  add_subdirectory(documentation)
endif()


find_program(qmltestrunner_exe qmltestrunner)

if(NOT qmltestrunner_exe)
  msg(FATAL_ERROR "Could not locate qmltestrunner.")
endif()

macro(add_qml_test COMPONENT_NAME)
    set(options NO_ADD_TEST NO_TARGETS)

    cmake_parse_arguments(qmltest "${options}" "IMPORT_PATH" "TARGETS" ${ARGN})

    set(qmltest_TARGET test${COMPONENT_NAME})
    set(qmltest_FILE tst_${COMPONENT_NAME})

    if("${qmltest_IMPORT_PATH}" STREQUAL "")
        add_custom_target(${qmltest_TARGET}
            ${qmltestrunner_exe}  -input ${CMAKE_CURRENT_SOURCE_DIR}/${qmltest_FILE}.qml
                          -o ${CMAKE_BINARY_DIR}/${qmltest_TARGET}.xml,xunitxml
                          -o -,txt)
    else()
        add_custom_target(${qmltest_TARGET}
            ${qmltestrunner_exe} -input ${CMAKE_CURRENT_SOURCE_DIR}/${qmltest_FILE}.qml
                          -import ${qmltest_IMPORT_PATH}
                          -o ${CMAKE_BINARY_DIR}/${qmltest_TARGET}.xml,xunitxml
                          -o -,txt)
    endif()

    if(NOT "${qmltest_UNPARSED_ARGUMENTS}" STREQUAL "")
        set_target_properties(${qmltest_TARGET} ${qmltest_PROPERTIES})
    elseif(NOT "${qmltest_DEFAULT_PROPERTIES}" STREQUAL "")
        set_target_properties(${qmltest_TARGET} ${qmltest_DEFAULT_PROPERTIES})
    endif()

    if("${qmltest_NO_ADD_TEST}" STREQUAL FALSE AND NOT "${qmltest_DEFAULT_NO_ADD_TEST}" STREQUAL "TRUE")
        add_test(${qmltest_TARGET} make ${qmltest_TARGET})

        if(NOT "${qmltest_UNPARSED_ARGUMENTS}" STREQUAL "")
            set_tests_properties(${qmltest_TARGET} ${qmltest_PROPERTIES})
        elseif(NOT "${qmltest_DEFAULT_PROPERTIES}" STREQUAL "")
            set_tests_properties(${qmltest_TARGET} ${qmltest_DEFAULT_PROPERTIES})
        endif()
    endif("${qmltest_NO_ADD_TEST}" STREQUAL FALSE AND NOT "${qmltest_DEFAULT_NO_ADD_TEST}" STREQUAL "TRUE")

    if("${qmltest_NO_TARGETS}" STREQUAL "FALSE")
        if(NOT "${qmltest_TARGETS}" STREQUAL "")
            foreach(TARGET ${qmltest_TARGETS})
                add_dependencies(${TARGET} ${qmltest_TARGET})
            endforeach(TARGET)
        elseif(NOT "${qmltest_DEFAULT_TARGETS}" STREQUAL "")
            foreach(TARGET ${qmltest_DEFAULT_TARGETS})
                add_dependencies(${TARGET} ${qmltest_TARGET})
            endforeach(TARGET)
        endif()
    endif("${qmltest_NO_TARGETS}" STREQUAL "FALSE")
endmacro(add_qml_test)

option(ENABLE_TESTING "Enable testing." ON)
if(${ENABLE_TESTING})
  enable_testing()
  add_subdirectory(test)
  
  ADD_CUSTOM_TARGET(
    check
    ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure
  )
endif()

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
  ENABLE_COVERAGE_REPORT(TARGETS lomiri-action-qt lomiri-action-qml
                         FILTER /usr/include ${CMAKE_SOURCE_DIR}/test/* ${CMAKE_BINARY_DIR}/*)
endif()

=== src/CMakeLists.txt ===
if (NOT use_libhud2)
  add_subdirectory(libhud)
endif()

set(CORE_SRCS
    lomiri-action.cpp
    lomiri-preview-action.cpp
    lomiri-preview-parameter.cpp
    lomiri-preview-range-parameter.cpp
    lomiri-menu-item.cpp
    lomiri-action-manager.cpp
    lomiri-action-context.cpp
)

set(PUBLIC_HEADER_DIR "${CMAKE_SOURCE_DIR}/include/lomiri/action")

set(PUBLIC_HEADERS
    ${PUBLIC_HEADER_DIR}/Action
    ${PUBLIC_HEADER_DIR}/lomiri-action.h
    ${PUBLIC_HEADER_DIR}/PreviewAction
    ${PUBLIC_HEADER_DIR}/lomiri-preview-action.h
    ${PUBLIC_HEADER_DIR}/PreviewParameter
    ${PUBLIC_HEADER_DIR}/lomiri-preview-parameter.h
    ${PUBLIC_HEADER_DIR}/PreviewRangeParameter
    ${PUBLIC_HEADER_DIR}/lomiri-preview-range-parameter.h
#    Don't publish MenuItem yet as we don't have any consumers
#    ${PUBLIC_HEADER_DIR}/MenuItem
    ${PUBLIC_HEADER_DIR}/lomiri-menu-item.h
    ${PUBLIC_HEADER_DIR}/ActionManager
    ${PUBLIC_HEADER_DIR}/lomiri-action-manager.h
    ${PUBLIC_HEADER_DIR}/ActionContext
    ${PUBLIC_HEADER_DIR}/lomiri-action-context.h
)

include_directories(${HUD_INCLUDE_DIRS})

add_library(lomiri-action-qt SHARED
    ${CORE_SRCS}
    ${PUBLIC_HEADERS} # public headers have to be included here for Q_DECL_EXPORT to work properly
)
target_link_libraries (lomiri-action-qt ${HUD_LIBRARIES})

qt5_use_modules(lomiri-action-qt Core)

install(
  TARGETS lomiri-action-qt
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)


set(API_VERSION_MAJOR 1)
set(API_VERSION_MINOR 1)

set(SO_VERSION ${API_VERSION_MAJOR})

set_target_properties(lomiri-action-qt PROPERTIES
                      SOVERSION ${SO_VERSION}
)

set(PC_FILE_TARGET "${CMAKE_CURRENT_BINARY_DIR}/lomiri-action-qt-${API_VERSION_MAJOR}.pc")
set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}/lomiri-action-qt-${API_VERSION_MAJOR}")
set(ABSOLUTE_SO_FILE "${CMAKE_INSTALL_FULL_LIBDIR}/liblomiri-action-qt.so.${SO_VERSION}")
configure_file("lomiri-action-qt.pc.in" ${PC_FILE_TARGET} @ONLY)
install(
  FILES ${PC_FILE_TARGET}
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

#install the headers
install(FILES ${PUBLIC_HEADERS}
        DESTINATION "${includedir}/lomiri/action")

=== examples/action-context/CMakeLists.txt ===
set(EXAMPLE_SRCS
    action-context.cpp
)

add_executable(action-context ${EXAMPLE_SRCS})
target_link_libraries(action-context lomiri-action-qt)
qt5_use_modules(action-context Core Widgets)

=== examples/mail-app/CMakeLists.txt ===
set(EXAMPLE_SRCS
    mail-app.cpp
)

add_executable(mail-app ${EXAMPLE_SRCS})
target_link_libraries(mail-app lomiri-action-qt)
qt5_use_modules(mail-app Core Widgets)

=== examples/preview-action/CMakeLists.txt ===
set(EXAMPLE_SRCS
    preview-action.cpp
)

add_executable(preview-action ${EXAMPLE_SRCS})
target_link_libraries(preview-action lomiri-action-qt)
qt5_use_modules(preview-action Core Widgets)

=== test/cpp/CMakeLists.txt ===
set(TEST_SRCS
    main.cpp
    tst_action.cpp
    tst_previewaction.cpp
    tst_previewrangeparameter.cpp
#    tst_menuitem.cpp
    tst_actioncontext.cpp
    tst_actionmanager.cpp
)

set(testCommand dbus-test-runner -t ${CMAKE_CURRENT_BINARY_DIR}/cpptest
    -p -o -p ${CMAKE_BINARY_DIR}/cpptest.xml,xunitxml
    -p -o -p -,txt)

pkg_search_module(GIO REQUIRED gio-2.0)
include_directories(${GIO_INCLUDE_DIRS})

add_executable(cpptest ${TEST_SRCS})
target_link_libraries(cpptest lomiri-action-qt ${GIO_LIBRARIES})
qt5_use_modules(cpptest Core Test)

add_test(NAME cpp COMMAND ${testCommand})

=== qml/Lomiri/Action/CMakeLists.txt ===
set(CORE_SRCS
    plugin.cpp
    qml-action.cpp
    qml-preview-action.cpp
    qml-manager.cpp
    qml-context.cpp
)

# Build everything twice. Since we have only a few
# source files, this is not an issue. If it does
# become one, change tools so they use the plugin
# instead of calling the classes directly.

add_library(lomiri-action-qml SHARED
${CORE_SRCS}
)
target_link_libraries(lomiri-action-qml lomiri-action-qt)

qt5_use_modules(lomiri-action-qml Qml)

get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
exec_program(${QMAKE_EXECUTABLE} ARGS "-query QT_INSTALL_QML" OUTPUT_VARIABLE QT_IMPORTS_DIR)
file(TO_CMAKE_PATH "${QT_IMPORTS_DIR}" QT_IMPORTS_DIR)

install(
  TARGETS lomiri-action-qml
  ARCHIVE DESTINATION ${QT_IMPORTS_DIR}/Lomiri/Action
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${QT_IMPORTS_DIR}/Lomiri/Action
)

install(
  FILES qmldir
  DESTINATION ${QT_IMPORTS_DIR}/Lomiri/Action
)

# copy qmldir file into build directory for shadow builds
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/qmldir"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
    )

=== debian/changelog ===
lomiri-action-api (1.1.2-3) unstable; urgency=medium

  * Re-upload source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 04 Feb 2023 16:20:14 +0100

lomiri-action-api (1.1.2-2) unstable; urgency=medium

  * debian/control:
    + Drop from D (dev:pkg): libhud2-dev. Using the bundled libhud-2 API.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Feb 2023 22:20:26 +0100

lomiri-action-api (1.1.2-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1030324).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Feb 2023 22:07:46 +0100

=== debian/control ===
Source: lomiri-action-api
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libglib2.0-dev,
               pkg-config,
               qt5-qmake,
               qtbase5-dev,
               qttools5-dev-tools,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qml-module-qtquick2,
               qml-module-qttest,
               dbus-test-runner,
               doxygen,
               graphviz,
               rdfind,
               symlinks,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-action-api
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-action-api.git
Vcs-Browser: https://salsa.debian.org/ubports-team/core/lomiri-action-api

Package: liblomiri-action-qt1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Action Qt API
 Lomiri Common Action API. Allow applications to export actions in
 various forms to the Lomiri Shell.
 .
 This package provides the Qt library of the API.

Package: liblomiri-action-qt1-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-action-qt1 (= ${binary:Version}),
         qtbase5-dev,
Suggests: lomiri-action-doc,
Description: Lomiri Action Qt API - development files
 Lomiri Common Action API. Allow applications to export actions in
 various forms to the Lomiri Shell.
 .
 This package contains development files to develop against the library.

Package: qml-module-lomiri-action
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-action-qt1 (= ${binary:Version}),
Description: Lomiri Action QML Components
 Lomiri Common Action API. Allow applications to export actions in
 various forms to the Lomiri Shell.
 .
 This package contains the qtdeclarative binding for the lomiri-action
 library.

Package: lomiri-action-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Action API - documentation
 Lomiri Common Action API. Allow applications to export actions in
 various forms to the Lomiri Shell.
 .
 This package contains developer documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Comment this to turn off verbose mode.
#export DH_VERBOSE=1

export DPKG_GENSYMBOLS_CHECK_LEVEL=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DGENERATE_DOCUMENTATION=ON	\
	                     -Duse_libhud2=OFF			\
	                     $(NULL)

override_dh_install:
	mv debian/tmp/usr/share/doc/lomiri-action debian/tmp/usr/share/doc/lomiri-action-doc
	rdfind -makesymlinks true "debian/tmp/usr/share/doc/lomiri-action-doc/"
	symlinks -rc "debian/tmp/usr/share/doc/lomiri-action-doc/"
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -Nqml-module-lomiri-action

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri-action-api/tags .*/lomiri-action-api-(\d\S+)\.tar\.gz

## lomiri-action-api 1.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(lomiri-action VERSION 1.1.2 LANGUAGES CXX C)
+project(lomiri-action VERSION 1.1.3 LANGUAGES CXX C)
 
 if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
@@ -69,7 +69,10 @@
 # Static C++ checks
 add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                        ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)
+find_package(Qt5Core REQUIRED)
 find_package(Qt5Quick REQUIRED)
+find_package(Qt5Widgets REQUIRED)
+find_package(Qt5Qml REQUIRED)
 
 include_directories(include)
 add_subdirectory(src)
@@ -85,7 +88,7 @@
 find_program(qmltestrunner_exe qmltestrunner)
 
 if(NOT qmltestrunner_exe)
-  msg(FATAL_ERROR "Could not locate qmltestrunner.")
+  message(FATAL_ERROR "Could not locate qmltestrunner.")
 endif()
 
 macro(add_qml_test COMPONENT_NAME)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 )
 target_link_libraries (lomiri-action-qt ${HUD_LIBRARIES})
 
-qt5_use_modules(lomiri-action-qt Core)
+target_link_libraries(lomiri-action-qt Qt5::Core)
 
 install(
   TARGETS lomiri-action-qt

=== documentation/qml/CMakeLists.txt ===
# add a target to generate API documentation with qdoc
if(DEFINED ENV{DEB_BUILD_MULTIARCH})
  set(QDOC_EXECUTABLE "/usr/lib/$ENV{DEB_BUILD_MULTIARCH}/qt5/bin/qdoc")
else()
  FIND_PROGRAM(QDOC_EXECUTABLE qdoc)
endif()
if(QDOC_EXECUTABLE)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lomiri-action-qml.qdocconf.in ${CMAKE_CURRENT_BINARY_DIR}/lomiri-action-qml.qdocconf @ONLY)
add_custom_target(qmldoc
${QDOC_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/lomiri-action-qml.qdocconf
WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
COMMENT "Generating QML API documentation with qdoc" VERBATIM
)

# copy stylesheet files into build directory for shadow builds
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/css"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
    )

install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
  DESTINATION ${CMAKE_INSTALL_DOCDIR}/qml/
)

endif(QDOC_EXECUTABLE)

=== examples/action-context/CMakeLists.txt ===
set(EXAMPLE_SRCS
    action-context.cpp
)

add_executable(action-context ${EXAMPLE_SRCS})
target_link_libraries(action-context lomiri-action-qt)
target_link_libraries(action-context Qt5::Core Qt5::Widgets)

=== examples/mail-app/CMakeLists.txt ===
set(EXAMPLE_SRCS
    mail-app.cpp
)

add_executable(mail-app ${EXAMPLE_SRCS})
target_link_libraries(mail-app lomiri-action-qt)
target_link_libraries(mail-app Qt5::Core Qt5::Widgets)

=== examples/preview-action/CMakeLists.txt ===
set(EXAMPLE_SRCS
    preview-action.cpp
)

add_executable(preview-action ${EXAMPLE_SRCS})
target_link_libraries(preview-action lomiri-action-qt)
target_link_libraries(preview-action Qt5::Core Qt5::Widgets)

=== src/libhud/CMakeLists.txt ===
set(CMAKE_AUTOMOC OFF)

include(UseGdbusCodegen)
include(UseGlibGeneration)

set(HUD_SERVICE_XML ${CMAKE_CURRENT_SOURCE_DIR}/data/com.canonical.hud.xml)
set(HUD_APP_XML ${CMAKE_CURRENT_SOURCE_DIR}/data/com.canonical.hud.Application.xml)

set(HUD_INCLUDE_DIRS
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

set(HUD_INCLUDE_DIRS
  ${HUD_INCLUDE_DIRS}
  PARENT_SCOPE
)

set(HUD_LIBRARIES
  hud
)

set(HUD_LIBRARIES
  ${HUD_LIBRARIES}
  PARENT_SCOPE
)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -fPIC")

include_directories(${HUD_INCLUDE_DIRS})
include_directories(${HUD_SRC_DIR})

add_definitions(-DHUD_COMPILATION=1)

###########################
# Generated Lib Hud
###########################

set(HUD_GENERATED_HEADERS
  app-iface.h
  service-iface.h
  marshal.h
)

set(HUD_GENERATED_SOURCES)

message(${HUD_SERVICE_XML})

add_gdbus_codegen(
  OUTFILES HUD_GENERATED_SOURCES
  NAME service-iface
  PREFIX com.canonical.hud.
  NAMESPACE _HudServiceIface
  SERVICE_XML ${HUD_SERVICE_XML}
)

add_gdbus_codegen(
  OUTFILES HUD_GENERATED_SOURCES
  NAME app-iface
  PREFIX com.canonical.hud.Application.
  NAMESPACE _HudAppIface
  SERVICE_XML ${HUD_APP_XML}
)

add_glib_marshal(HUD_GENERATED_SOURCES
  marshal
  _hud_marshal
  marshal.h
)

message(${HUD_GENERATED_SOURCES})
add_library(hud-generated STATIC ${HUD_GENERATED_SOURCES})

target_link_libraries(hud-generated
  ${GLIB2_LIBRARIES}
  ${GOBJECT2_LIBRARIES}
  ${GIO2_LIBRARIES}
)

###########################
# Lib Hud
###########################

set(HUD_MAIN_HEADERS
  hud.h
)

set(HUD_HEADERS
  manager.h
  action-publisher.h
  ${HUD_HEADERS}
)

set(HUD_SOURCES
  manager.c
  action-publisher.c
)

message(${HUD_SOURCES})
add_library(hud STATIC ${HUD_SOURCES})

target_link_libraries(${HUD_LIBRARIES}
  hud-generated
  ${GLIB2_LIBRARIES}
  ${GOBJECT2_LIBRARIES}
)

=== test/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,7 @@
 
 add_executable(cpptest ${TEST_SRCS})
 target_link_libraries(cpptest lomiri-action-qt ${GIO_LIBRARIES})
-qt5_use_modules(cpptest Core Test)
+find_package(Qt5Test REQUIRED)
+target_link_libraries(cpptest Qt5::Core Qt5::Test)
 
 add_test(NAME cpp COMMAND ${testCommand})

=== test/qml/CMakeLists.txt ===
add_custom_target(qmlunittests)
add_custom_target(qmlunittests_1_1)

find_program(qmltestrunner_exe qmltestrunner)

if(NOT qmltestrunner_exe)
  message(FATAL_ERROR "Could not locate qmltestrunner.")
endif()

set(qmltest_command
  dbus-test-runner -t env -p "QT_QPA_PLATFORM=minimal"
  -p ${qmltestrunner_exe} -p -input -p ${CMAKE_CURRENT_SOURCE_DIR}/tst_api.qml
  -p -import -p ${CMAKE_CURRENT_BINARY_DIR}/../../qml
  -p -o -p ${CMAKE_BINARY_DIR}/testapi.xml,xunitxml
  -p -o -p -,txt
)

add_custom_target(qmltest_api ${qmltest_command})
add_dependencies(qmlunittests qmltest_api)
add_test(qmlunittests ${qmltest_command})

set(qmltest1_1_command
  dbus-test-runner -t env -p "QT_QPA_PLATFORM=minimal"
  -p ${qmltestrunner_exe} -p -input -p ${CMAKE_CURRENT_SOURCE_DIR}/tst_api1.1.qml
  -p -import -p ${CMAKE_CURRENT_BINARY_DIR}/../../qml
  -p -o -p ${CMAKE_BINARY_DIR}/testapi.xml,xunitxml
  -p -o -p -,txt
)

add_custom_target(qmltest_1_1_api ${qmltest1_1_command})
add_dependencies(qmlunittests_1_1 qmltest_1_1_api)
add_test(qmlunittests_1_1 ${qmltest1_1_command})

=== qml/Lomiri/Action/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 )
 target_link_libraries(lomiri-action-qml lomiri-action-qt)
 
-qt5_use_modules(lomiri-action-qml Qml)
+target_link_libraries(lomiri-action-qml Qt5::Qml)
 
 get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
 exec_program(${QMAKE_EXECUTABLE} ARGS "-query QT_INSTALL_QML" OUTPUT_VARIABLE QT_IMPORTS_DIR)

=== debian/changelog ===
lomiri-action-api (1.1.3-1build5) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:38:59 +0000

lomiri-action-api (1.1.3-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:58:06 +0000

lomiri-action-api (1.1.3-1build3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:44:06 +0000

lomiri-action-api (1.1.3-1build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:08:11 +0000

lomiri-action-api (1.1.3-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:34:36 +0000

lomiri-action-api (1.1.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attribution for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 01 Feb 2024 21:47:26 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: lomiri-action-api
 Section: libs
 Priority: optional
-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),

## lomiri-action-api 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(lomiri-action VERSION 1.1.3 LANGUAGES CXX C)
+project(lomiri-action-api VERSION 1.2.0 LANGUAGES CXX C)
 
 if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
@@ -15,6 +15,13 @@
 
 option(basic_warnings "Basic compiler warnings." ON)
 option(use_libhud2 "Use external libhud2 lib" ON)
+option(ENABLE_QT6 "Enable Qt6" OFF)
+if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
+    option(ENABLE_WERROR "Treat warnings as errors" ON)
+else()
+    option(ENABLE_WERROR "Treat warnings as errors" OFF)
+endif()
+
 include(FindPkgConfig)
 
 if (use_libhud2)
@@ -30,16 +37,10 @@
     include_directories(${GIO2_INCLUDE_DIRS})
 endif()
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11 -fno-permissive -pedantic -Wall -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++17 -fno-permissive -pedantic -Wall -Wextra")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
 
-if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
-    option(Werror "Treat warnings as errors" ON)
-else()
-    option(Werror "Treat warnings as errors" OFF)
-endif()
-
-if (Werror)
+if (ENABLE_WERROR)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
 endif()
 
@@ -69,10 +70,16 @@
 # Static C++ checks
 add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                        ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)
-find_package(Qt5Core REQUIRED)
-find_package(Qt5Quick REQUIRED)
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5Qml REQUIRED)
+
+if (ENABLE_QT6)
+    find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core Qml)
+    set(QT_VERSION_IN_LIBNAME ${QT_VERSION_MAJOR})
+else()
+    find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core Qml)
+    set(QT_VERSION_IN_LIBNAME "")
+endif()
+
+find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Widgets Quick Qml)
 
 include_directories(include)
 add_subdirectory(src)
@@ -145,7 +152,7 @@
 if(${ENABLE_TESTING})
   enable_testing()
   add_subdirectory(test)
-  
+
   ADD_CUSTOM_TARGET(
     check
     ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure

=== documentation/cpp/CMakeLists.txt ===
# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
add_custom_target(cppdoc
${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
COMMENT "Generating C++ API documentation with Doxygen" VERBATIM
)


install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
  DESTINATION ${CMAKE_INSTALL_DOCDIR}/cpp/
)

endif(DOXYGEN_FOUND)

=== examples/preview-action/CMakeLists.txt ===
set(EXAMPLE_SRCS
    preview-action.cpp
)

add_executable(preview-action ${EXAMPLE_SRCS})
target_link_libraries(preview-action lomiri-action-qt${QT_VERSION_IN_LIBNAME})
target_link_libraries(preview-action Qt::Core Qt::Widgets)

=== qml/Lomiri/CMakeLists.txt ===
add_subdirectory(Action)

=== debian/changelog ===
lomiri-action-api (1.2.0-2) unstable; urgency=medium

  * debian/rules:
    + Don't fail during dh_installdocs override when building with -B
      debbuildopts.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 31 Mar 2025 08:11:54 +0200

lomiri-action-api (1.2.0-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * New upstream release.
  * debian/:
    + Dually build against Qt5 and Qt6. This adds various new bin:pkg to the
      build result.
    + Rename doc:pkg (lomiri-action-doc -> lomiri-action-api-doc).
  * debian/patches/1001_typo-fixes.patch:
    + Amend patch, don't fix grammar issues in parts of the API, even if that
      uses wrong grammar. :-/.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
    + In B-D, switch from pkg-config to pkgconf. Thanks, lintian.
    + Add B:/R: for old name lomiri-action-doc doc:pkg (so it gets removed
      once the newer lomiri-action-api-doc doc:pkg gets installed).
  * debian/rules:
    + Stop excluding the QML module qml:pkg from dh_makeshlibs.
    + Silence Qt6 complaints about LANG=C.
    + No need to move API docs, folder renamed by upstream since this release.
    + Remove build cruft during dh_clean. (Closes: #1047231).
  * debian/copyright:
    + Update copyright attributions for debian/.
    + Use new FSF mailing address.

  [ Vagrant Cascadian ]
  * Reproducible Builds fixes: (Closes: #1034129)
    + debian/rules:
      - Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON via dh_auto_configure override.
      - Add dh_installdocs override to remove build path from lomiri-action-qml-
        api.index.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 30 Mar 2025 11:56:47 +0200

lomiri-action-api (1.1.3-2) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Jan 2025 15:55:28 +0100

=== debian/control ===
Source: lomiri-action-api
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libglib2.0-dev,
               pkgconf,
               qt6-base-dev,
               qt6-tools-dev-tools,
               qt6-declarative-dev,
               qt6-declarative-dev-tools,
               qml6-module-qtquick,
               qml6-module-qttest,
               qtbase5-dev,
               qttools5-dev-tools,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qml-module-qtquick2,
               qml-module-qttest,
               dbus-test-runner,
               doxygen,
               graphviz,
               rdfind,
               symlinks,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-action-api
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-action-api.git
Vcs-Browser: https://salsa.debian.org/ubports-team/core/lomiri-action-api

Package: liblomiri-action-qt6-1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Action Qt6 API
 Lomiri Common Action API (built against Qt6). Allow applications to
 export actions in various forms to the Lomiri Shell.

Package: liblomiri-action-qt1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Action Qt5 API
 Lomiri Common Action API (built against Qt5). Allow applications to
 export actions in various forms to the Lomiri Shell.

Package: liblomiri-action-qt6-1-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-action-qt6-1 (= ${binary:Version}),
         qt6-base-dev,
Suggests: lomiri-action-doc,
Description: Lomiri Action Qt6 API - development files
 Lomiri Common Action API (built against Qt6). Allow applications to
 export actions in various forms to the Lomiri Shell.
 .
 This package contains development files to develop against the library.

Package: liblomiri-action-qt1-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-action-qt1 (= ${binary:Version}),
         qtbase5-dev,
Suggests: lomiri-action-doc,
Description: Lomiri Action Qt5 API - development files
 Lomiri Common Action API (built against Qt5). Allow applications to
 export actions in various forms to the Lomiri Shell.
 .
 This package contains development files to develop against the library.

Package: qml6-module-lomiri-action
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-action-qt6-1 (= ${binary:Version}),
Description: Lomiri Action QML Components (Qt6)
 Lomiri Common Action API (Qt6 version). Allow applications to
 export actions in various forms to the Lomiri Shell.
 .
 This package contains the qtdeclarative binding for the lomiri-action
 library.

Package: qml-module-lomiri-action
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-action-qt1 (= ${binary:Version}),
Description: Lomiri Action QML Components (Qt5)
 Lomiri Common Action API (Qt5 version). Allow applications to
 export actions in various forms to the Lomiri Shell.
 .
 This package contains the qtdeclarative binding for the lomiri-action
 library.

Package: lomiri-action-api-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: lomiri-action-doc,
Replaces: lomiri-action-doc,
Description: Lomiri Action API - documentation
 Lomiri Common Action API. Allow applications to
 export actions in various forms to the Lomiri Shell.
 .
 This package contains developer documentation.

## lomiri-action-api 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 # Default install location. Must be set here, before setting the project.
 if (NOT DEFINED CMAKE_INSTALL_PREFIX)
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(lomiri-action-api VERSION 1.2.0 LANGUAGES CXX C)
+project(lomiri-action-api VERSION 1.2.1 LANGUAGES CXX C)
 
 if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")

=== documentation/CMakeLists.txt ===
add_subdirectory(cpp)
add_subdirectory(qml)

add_custom_target(doc ALL)
add_dependencies(doc cppdoc qmldoc)

=== examples/CMakeLists.txt ===
add_subdirectory(action-context)
add_subdirectory(preview-action)
add_subdirectory(mail-app)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -34,16 +34,16 @@
 
 include_directories(${HUD_INCLUDE_DIRS})
 
-add_library(lomiri-action-qt SHARED
+add_library(lomiri-action-qt${QT_VERSION_IN_LIBNAME} SHARED
     ${CORE_SRCS}
     ${PUBLIC_HEADERS} # public headers have to be included here for Q_DECL_EXPORT to work properly
 )
-target_link_libraries (lomiri-action-qt ${HUD_LIBRARIES})
+target_link_libraries(lomiri-action-qt${QT_VERSION_IN_LIBNAME} ${HUD_LIBRARIES})
 
-target_link_libraries(lomiri-action-qt Qt5::Core)
+target_link_libraries(lomiri-action-qt${QT_VERSION_IN_LIBNAME} Qt::Core)
 
 install(
-  TARGETS lomiri-action-qt
+  TARGETS lomiri-action-qt${QT_VERSION_IN_LIBNAME}
   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   RUNTIME DESTINATION bin
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
@@ -55,14 +55,14 @@
 
 set(SO_VERSION ${API_VERSION_MAJOR})
 
-set_target_properties(lomiri-action-qt PROPERTIES
+set_target_properties(lomiri-action-qt${QT_VERSION_IN_LIBNAME} PROPERTIES
                       SOVERSION ${SO_VERSION}
 )
 
-set(PC_FILE_TARGET "${CMAKE_CURRENT_BINARY_DIR}/lomiri-action-qt-${API_VERSION_MAJOR}.pc")
+set(PC_FILE_TARGET "${CMAKE_CURRENT_BINARY_DIR}/lomiri-action-qt${QT_VERSION_IN_LIBNAME}-${API_VERSION_MAJOR}.pc")
 set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
-set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}/lomiri-action-qt-${API_VERSION_MAJOR}")
-set(ABSOLUTE_SO_FILE "${CMAKE_INSTALL_FULL_LIBDIR}/liblomiri-action-qt.so.${SO_VERSION}")
+set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}/lomiri-action-qt${QT_VERSION_IN_LIBNAME}-${API_VERSION_MAJOR}")
+set(ABSOLUTE_SO_FILE "${CMAKE_INSTALL_FULL_LIBDIR}/liblomiri-action-qt${QT_VERSION_IN_LIBNAME}.so.${SO_VERSION}")
 configure_file("lomiri-action-qt.pc.in" ${PC_FILE_TARGET} @ONLY)
 install(
   FILES ${PC_FILE_TARGET}

=== test/CMakeLists.txt ===
add_subdirectory(cpp)
add_subdirectory(qml)

=== documentation/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,7 @@
 
 install(
   DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
-  DESTINATION ${CMAKE_INSTALL_DOCDIR}/cpp/
+  DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR}/cpp/
 )
 
 endif(DOXYGEN_FOUND)
-

=== documentation/qml/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 install(
   DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
-  DESTINATION ${CMAKE_INSTALL_DOCDIR}/qml/
+  DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR}/qml/
 )
 
 endif(QDOC_EXECUTABLE)

=== examples/action-context/CMakeLists.txt ===
set(EXAMPLE_SRCS
    action-context.cpp
)

add_executable(action-context ${EXAMPLE_SRCS})
target_link_libraries(action-context lomiri-action-qt${QT_VERSION_IN_LIBNAME})
target_link_libraries(action-context Qt::Core Qt::Widgets)

=== examples/mail-app/CMakeLists.txt ===
set(EXAMPLE_SRCS
    mail-app.cpp
)

add_executable(mail-app ${EXAMPLE_SRCS})
target_link_libraries(mail-app lomiri-action-qt${QT_VERSION_IN_LIBNAME})
target_link_libraries(mail-app Qt::Core Qt::Widgets)

=== test/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -16,8 +16,10 @@
 include_directories(${GIO_INCLUDE_DIRS})
 
 add_executable(cpptest ${TEST_SRCS})
-target_link_libraries(cpptest lomiri-action-qt ${GIO_LIBRARIES})
-find_package(Qt5Test REQUIRED)
-target_link_libraries(cpptest Qt5::Core Qt5::Test)
+target_link_libraries(cpptest lomiri-action-qt${QT_VERSION_IN_LIBNAME} ${GIO_LIBRARIES})
+
+find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)
+
+target_link_libraries(cpptest Qt::Core Qt::Test)
 
 add_test(NAME cpp COMMAND ${testCommand})

=== test/qml/CMakeLists.txt ===
add_custom_target(qmlunittests)
add_custom_target(qmlunittests_1_1)

set(CHECK_DEFAULT_PATH "")
if (EXISTS "/etc/debian_version")
    set(CHECK_DEFAULT_PATH "NO_DEFAULT_PATH")
endif()
find_program(QMLTESTRUNNER qmltestrunner REQUIRED
             PATHS /usr/lib/qt${QT_VERSION_MAJOR}/bin
             ${CHECK_DEFAULT_PATH}
)

if(NOT QMLTESTRUNNER)
  message(FATAL_ERROR "Could not locate qmltestrunner.")
endif()

set(qmltest_command
  dbus-test-runner -t env -p "QT_QPA_PLATFORM=minimal"
  -p ${QMLTESTRUNNER} -p -input -p ${CMAKE_CURRENT_SOURCE_DIR}/tst_api.qml
  -p -import -p ${CMAKE_CURRENT_BINARY_DIR}/../../qml
  -p -o -p ${CMAKE_BINARY_DIR}/testapi.xml,xunitxml
  -p -o -p -,txt
)

add_custom_target(qmltest_api ${qmltest_command})
add_dependencies(qmlunittests qmltest_api)
add_test(qmlunittests ${qmltest_command})

set(qmltest1_1_command
  dbus-test-runner -t env -p "QT_QPA_PLATFORM=minimal"
  -p ${QMLTESTRUNNER} -p -input -p ${CMAKE_CURRENT_SOURCE_DIR}/tst_api1.1.qml
  -p -import -p ${CMAKE_CURRENT_BINARY_DIR}/../../qml
  -p -o -p ${CMAKE_BINARY_DIR}/testapi.xml,xunitxml
  -p -o -p -,txt
)

add_custom_target(qmltest_1_1_api ${qmltest1_1_command})
add_dependencies(qmlunittests_1_1 qmltest_1_1_api)
add_test(qmlunittests_1_1 ${qmltest1_1_command})

=== qml/Lomiri/Action/CMakeLists.txt ===
set(CORE_SRCS
    plugin.cpp
    qml-action.cpp
    qml-preview-action.cpp
    qml-manager.cpp
    qml-context.cpp
)

# Build everything twice. Since we have only a few
# source files, this is not an issue. If it does
# become one, change tools so they use the plugin
# instead of calling the classes directly.

add_library(lomiri-action-qml SHARED
${CORE_SRCS}
)
target_link_libraries(lomiri-action-qml lomiri-action-qt${QT_VERSION_IN_LIBNAME})

target_link_libraries(lomiri-action-qml Qt::Qml)

set(QML_PLUGIN_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml")

install(
  TARGETS lomiri-action-qml
  ARCHIVE DESTINATION ${QML_PLUGIN_DIR}/Lomiri/Action
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${QML_PLUGIN_DIR}/Lomiri/Action
)

install(
  FILES qmldir
  DESTINATION ${QML_PLUGIN_DIR}/Lomiri/Action
)

# copy qmldir file into build directory for shadow builds
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/qmldir"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
    )

=== debian/changelog ===
lomiri-action-api (1.2.1-1) unstable; urgency=medium

  * New upstream release.
    - Support building with CMake 4. (Closes: #1113239).
  * debian/lomiri-action-api-doc.compress:
    + Don't auto-compress any documentation files. This breaks browsing
      the docs in a webbrowser and thus should be avoided.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Oct 2025 16:32:29 +0200

=== debian/control ===
--- 
+++ 
@@ -113,6 +113,7 @@
 Package: lomiri-action-api-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends},
 Breaks: lomiri-action-doc,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Comment this to turn off verbose mode.
#export DH_VERBOSE=1

export DPKG_GENSYMBOLS_CHECK_LEVEL=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Silence Qt6 complaints about LANG=C
export LANG=C.UTF-8

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-qt6 --buildsystem=cmake -- \
	                  -DGENERATE_DOCUMENTATION=OFF \
	                  -DENABLE_QT6=ON \
	                  -DENABLE_WERROR=OFF \
	                  -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	                  -Duse_libhud2=OFF \
	                  ..
	dh_auto_configure --builddirectory=build-qt5 --buildsystem=cmake -- \
	                  -DGENERATE_DOCUMENTATION=ON \
	                  -DENABLE_QT6=OFF \
	                  -DENABLE_WERROR=OFF \
	                  -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	                  -Duse_libhud2=OFF \
	                  ..

override_dh_auto_build:
	dh_auto_build --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_build --builddirectory=build-qt5 --buildsystem=cmake ..

override_dh_auto_test:
#	LANG=$(LANG) dh_auto_test --builddirectory=build-qt6 ..
	LANG=$(LANG) dh_auto_test --builddirectory=build-qt5 ..

override_dh_auto_install:
	LANG=$(LANG) dh_auto_install --no-parallel \
	                             --builddirectory=build-qt6 \
	                             --buildsystem=cmake \
	                             ..
	LANG=$(LANG) dh_auto_install --no-parallel \
	                             --builddirectory=build-qt5 \
	                             --buildsystem=cmake \
	                             ..

override_dh_install:
	mv debian/tmp/usr/share/doc/lomiri-action-api debian/tmp/usr/share/doc/lomiri-action-api-doc
	rdfind -makesymlinks true "debian/tmp/usr/share/doc/lomiri-action-api-doc/"
	symlinks -rc "debian/tmp/usr/share/doc/lomiri-action-api-doc/"
	dh_install

override_dh_installdocs:
	dh_installdocs
	# Remove the build directory from the generated documentation for reproducible builds (fails for arch:any-only builds)
	-sed -i -e "s,$(CURDIR),,g" debian/lomiri-action-api-doc/usr/share/doc/lomiri-action-api-doc/qml/lomiri-action-qml-api.index

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_clean --builddirectory=build-qt5 --buildsystem=cmake ..

override_dh_clean:
	dh_clean
	-rm results.txt

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
